import functools
from pathlib import Path
import random
import struct
import time

def waste_time_rand():
    time.sleep(random.randint(0, 3))

def waste_time(t: int):
    time.sleep(t)

def gen_binary_file(file_name: str | Path, N: int):
    with open(file_name, 'wb') as f:
        for _ in range(N):
            f.write(struct.pack('f', random.uniform(-1000.0, 1000.0)))

def read_binary_file(file_name) -> list[float]:
    ret = []
    with open(file_name, 'rb') as f:
        while True:
            aux = f.read(4)
            if not aux:
                break
            ret.append(struct.unpack('f', aux)[0])
    return ret

def measure(fun):
    @functools.wraps(fun)
    def wrapper(*args, **kwargs):
        start = time.time()
        ret = fun(*args, **kwargs)
        end = time.time()
        print(f"{fun.__name__}: {end - start:.4f} s")
        return ret
    return wrapper

